#include <chrono>
#include <pybind11/pybind11.h>
#include <pybind11/chrono.h>
#include <pybind11/functional.h>

#include "simplesync.hpp"

namespace py = pybind11;
typedef simplesync::SimpleSync<std::chrono::time_point<std::chrono::steady_clock>,
                               std::chrono::nanoseconds>
    SimpleS;


PYBIND11_MODULE(pysimplesync, m) {
    py::class_<SimpleS>(m, "SimpleSync")
        .def(py::init([]() { return std::unique_ptr<SimpleS>(new SimpleS([](uint8_t * buf, unsigned int buf_size){
            py::print(std::string((char*)buf, buf_size));
            return 0;},[](SimpleS::NumberInterface *& ni, char * key, int value){
                py::print(std::string(key), ": ",value);
            },nullptr)); }))
        .def("update", [](SimpleS &s){
            s.update(std::chrono::steady_clock::now());
        })
        .def("handle_stream", [](SimpleS &s, const std::string& buf_new) {
            /* handle_stream(b'\x06\x01\x74\x65\x73\x74\x04\x6d\x21\x97\x00') */
            s.handle_stream((const uint8_t*)buf_new.data(), buf_new.length() );
        });
}
